# ֤ʤĤߤ״ܥ饤֥ѥå  ver.2.3.1(20000125)
# "NATSU-MICAN" Copyright (C) 1998-2000 hiya All Rights Reserved.

# С
$version = '2.3';
$modified = '20000120';
$version .= "(".$modified.")";
$UserAgent = 'NATSU-MICAN/';
$UserAgent .= $version;


# 
package nm_lib;
use Time::Local;
use IO::Socket;
use IO::Select;


##
# lm2time(opt1, opt2)
# ͡ʷλɽ顢timeФ
# opt2Ϥλɽλӡɽ˻Ӥ񤫤ƤʤȤΤͭ
sub lm2time($;$){
	$_ = shift;
	my $timezone = 0;
	$timezone = shift;

	my $time = undef;
	my ($y, $m, $d, $H, $M, $S, $Z) = 0;
	my $this_time = time;
	my $this_year = (gmtime($this_time))[5];
	my $one_hour = 60 * 10;
	my $week = 60 * 60 * 24 * 7;

	# ʬ
	if(m%(\d+):(\d+):(\d+)%){
		$H = $1;
		$M = $2;
		$S = $3;
	}elsif(m%(\d+):(\d+)%){
		$H = $1;
		$M = $2;
		$S = 0;
	}

	# ǯ
	if(m%(\d+)/(\d+)/(\d+)%){
		$y = $1;
		$m = $2 - 1;
		$d = $3;
	}elsif(m%(\d+)/(\d+)%){
		$y = $this_year;
		$m = $1 - 1;
		$d = $2;
	}elsif(m%(\d+)\.(\d+)\.(\d+)%){
		$y = $1;
		$m = $2 - 1;
		$d = $3;
	}elsif(m%(\d+)\-(\d+)\-(\d+)%){
		$y = $1;
		$m = $2 - 1;
		$d = $3;
	}
	$Z = $timezone;

	if(m%\w+,\s+(\d+)\s(\w{3})\s(\d\d+)\s(\d+):(\d+):(\d+)\s(\w{3,4})%io){
		# rfc1123 "Sun, 06 Nov 1994 08:49:37 GMT"
		$Z = $7; $S = $6; $M = $5; $H = $4; $d = $1; $m = &month2num($2); $y = $3;

	}elsif(m%\w+\s(\w+)\s+(\d+)\s(\d+):(\d+):(\d+)\s(\d+)%io){
		# Sun Nov 6 08:49:37 1994(ANSI C's asctime() format) 
		$Z = $timezone; $S = $5; $M = $4; $H = $3; $d = $2; $m = &month2num($1); $y = $6;

	}elsif(m%\w+,\s(\d+)\-(\w+)\-(\d+)\s(\d+):(\d+):(\d+)\s(\w{3,4})%io){
		# rfc1036 "Sunday, 06-Nov-94 08:49:37 GMT"
		$Z = $7; $S = $6; $M = $5; $H = $4; $d = $1; $m = &month2num($2); $y = $3;

	}elsif(m%\w+,\s(\d+)\-(\w+)\-(\d+)\s(\d+):(\d+):(\d+)%io){
		# rfc1036 "Wednesday, 05-Jan-00 15:49:28"
		$Z = $timezone; $S = $6; $M = $5; $H = $4; $d = $1; $m = &month2num($2); $y = $3;

	}elsif(m%(\w+?)\s(\d+)\s(\d+):(\d+)%io){
		# Aug 20 22:02
		$Z = $timezone; $S = 0; $M = $4; $H = $3; $d = $2; $m = &month2num($1); $y = $this_year;

	}elsif(m%(\d+)/(\d+)/(\d+)\s(\d+):(\d+):(\d+)\s(\w{3,4})%io){
		# 1999/11/10 17:03:06 JST
		$Z = $7; $S = $6; $M = $5; $H = $4; $d = $3; $m = $2-1; $y = $1;

	}elsif(m%(\w+?)\s(\d+)\s(\d+)\s(\d+):(\d+)%io){
		# Oct 18 1999 17:40
		$Z = $timezone; $S = 0; $M = $5; $H = $4; $d = $2; $m = &month2num($1); $y = $3;

	}elsif(m%(\d+)(\d+)ʺǽ(\d+):(\d+)%io){
		# 1021ʺǽ22:20
		$Z = $timezone; $S = 0; $M = $4; $H = $3; $d = $2; $m = $1-1; $y = $this_year;

	}elsif(m%(\d+)\.(\d+)\.(\d+)\-(\d+):(\d+)%io){
		# 99.08.18-23:59
		$Z = $timezone; $S = 0; $M = $5; $H = $4; $d = $3; $m = $2-1; $y = $1;

	}elsif(m%(\d+)/(\d+)/(\d+)\(.+?\)\s(\d+):(\d+):(\d+)%io){
		# 99/08/31() 23:28:07
		$Z = $timezone; $S = $6; $M = $5; $H = $4; $d = $3; $m = $2-1; $y = $1;

	}elsif(m%(\d+)ǯ\s*(\d+)\s*(\d+)\s*(\w\w\s*)(\d+):(\d+)%io){
		# 1999ǯ 11 08 PM 08:40
		$Z = $timezone; $S = 0; $M = $6; $H = $5; $d = $3; $m = $2-1; $y = $1;
		$H += 12 if($4 =~ /pm/i && $H < 12);

	}elsif(m%(\d+)ǯ\s*(\d+)\s*(\d+),*?(\d+)(\d+)ʬ%io){
		# 1999ǯ1108(hoge)1538ʬ
		$Z = $timezone; $S = 0; $M = $5; $H = $4; $d = $3; $m = $2-1; $y = $1;

	}elsif(m%(\d+)\s*(\d+).*?(\d+)(\d+)ʬ(\d+)%io){
		# 1117(hoge)1314ʬ59
		$Z = $timezone; $S = $5; $M = $4; $H = $3; $d = $2; $m = $1-1; $y = $this_year;

	}elsif(m%$Id:\s.+?,.+?\s(\d\d+)-(\d+)-(\d+)\s(\d+):(\d+):(\d+)([0-9\+\-]+)\s.+?\s$%io){
		# $Id: hoge.html,v 1.7 1999-11-12 14:28:58+09 foo Exp foo $
		$Z = $7 * 60 * 60; $S = $6; $M = $5; $H = $4; $d = $3; $m = $2-1; $y = $1;

	}elsif(m%$Id:\s.+?,.+?\s(\d\d+)-(\d+)-(\d+)\s(\d+):(\d+):(\d+)\s.+?\s$%io){
		# $Id: hoge.html,v 1.7 1999-11-12 14:28:58 foo Exp foo $
		$Z = 0; $S = $6; $M = $5; $H = $4; $d = $3; $m = $2-1; $y = $1;

	}elsif(m%HINA_OK\s(\d\d\d\d)/(\d+)/(\d+)\s(\d+):(\d+)%io){
		# <!--HINA_OK 1998/10/23 00:48 
		$Z = $timezone; $S = 0; $M = $5; $H = $4; $d = $3; $m = $2-1; $y = $1;

	}elsif(m%HINA_OK\s(\d\d)/(\d+)/(\d+)\s(\d+):(\d+)%io){
		# <!--HINA_OK 98/10/23 00:48 
		$Z = $timezone; $S = 0; $M = $5; $H = $4; $d = $3; $m = $2-1; $y = $1;

	}elsif(m%(\d+)/(\d+)/(\d+)\s(\d+):(\d+):(\d+)%io){
		# 2000/01/16 23:41:42
		$Z = $timezone; $S = $6; $M = $5; $H = $4; $d = $3; $m = $2-1; $y = $1;

	}elsif(m%(\d+)/(\d+)\s(\d+):(\d+)%io){
		# 01/18 18:26
		$Z = $timezone; $S = 0; $M = $4; $H = $3; $d = $2; $m = $1-1; $y = $this_year;
	}

	$y -= 1900 if($y >= 1900);
	$y += 100 if($y < 70);

	if(((0 <= $S) && ($S <= 59)) && ((0 <= $M) && ($M <= 59)) && ((0 <= $H) && ($H <= 23)) && ((1 <= $d) && ($d <= 31)) && ((0 <= $m) && ($m <= 11)) && (70 <= $y)){
		$time = &nm_lib::timeglobal($Z, $S, $M, $H, $d, $m ,$y);
		if($time > $this_time + $week){
			$time = &nm_lib::timeglobal($Z, $S, $M, $H, $d, $m ,$y-1);
		}
	}

	$time;
}


##
# &alldirs($dir, $word)
# ꤵ줿ǥ쥯ȥ۲Υ֥ǥ쥯ȥޤƤΥեΤʤ顢ɤޤե֤
# $word'*'ꤵƤ硢Υǥ쥯ȥƤΥȥ꡼֤(ɤȤʤ)
# ξǡ顼ƥȤλϥ顼֤
# $wordɽѲǽ
sub alldirs($;$){
	my $DIR = shift;
	my $WORD = shift;
	my (@chkdirs, @files);
	my $a;

	$WORD = '*' unless($WORD);

	$DIR =~ s%/$%%g;

	push(@chkdirs, "$DIR");
	for(;;){
		$a = shift(@chkdirs);
		last if($a eq "");

		push(@files, &nm_lib::dirs($a, $WORD));
		push(@chkdirs, &nm_lib::dircheck($a));
	}

	wantarray ? @files : join('', @files);
}


##
# &dircheck($dir)
# ꤵ줿ǥ쥯ȥ۲Υ֥ǥ쥯ȥ$dir/dirȸΥѥ֤
sub dircheck(){
	my $DIR = shift;
	my @ret = ();
	my $a;

	opendir(CKDIR, "$DIR");
	while($a = readdir(CKDIR)){
		if(-d "$DIR/$a"){
			push(@ret, "$DIR/$a") unless($a =~ /^\.\.?$/);
		}
	}
	closedir(CKDIR);

	@ret;
}


##
# &dirs($dir, $word)
# ꤵ줿ǥ쥯ȥλꤵ줿ɤޤե$dir/fileȸΥѥ֤
# $word'*'ꤵƤ硢Υǥ쥯ȥƤΥȥ꡼֤
# ʤ֤ͤ˥ǥ쥯ȥϴޤޤʤ
sub dirs($$){
	my $DIR = shift;
	my $WORD = shift;
	my @ret = ();
	my $a;

	opendir(CKDIR, "$DIR");
	while($a = readdir(CKDIR)){
		if($WORD eq "*"){
			push(@ret, "$DIR/$a") unless(-d "$DIR/$a");
		}else{
			if($a =~ /$WORD/){
				push(@ret, "$DIR/$a") unless(-d "$DIR/$a");
			}
		}
	}
	closedir(CKDIR);

	@ret;
}


##
# month2num(opt1)
# Ѽɽ֤ͤ(mday);
sub month2num{
	my $mon = shift;

	my %month =	("Jan" => "0"
				,"Feb" => "1"
				,"Mar" => "2"
				,"Apr" => "3"
				,"May" => "4"
				,"Jun" => "5"
				,"Jul" => "6"
				,"Aug" => "7"
				,"Sep" => "8"
				,"Oct" => "9"
				,"Nov" => "10"
				,"Dec" => "11"
				);
	while(my ($key, $tgt) = each(%month)){
		$mon =~ s/.*$key.*/$tgt/i;
	}

	return $mon;
}


##
# tz2tzlag($tz)
# ॾɽGMTθ줫顢ॾɽGMTȤθξФ
# ॾɽɸϤˤäƤϥޡФ(ۤȤ)
sub tz2tzlag($){
	my $tz = shift;
	my $time = undef;
	my %stime =	("AST" => "ADT"
				,"AKST" => "AKDT"
				,"PST" => "PDT"
				,"MST" => "MDT"
				,"CST" => "CDT"
				,"EST" => "EDT"
				);
	my %szone =	("HST" => "-36000"
				,"PST" => "-28800"
				,"PDT" => "-25200"
				,"MST" => "-25200"
				,"MDT" => "-21600"
				,"CST" => "-21600"
				,"CDT" => "-18000"
				,"EST" => "-18000"
				,"EDT" => "-14400"
				,"GMT" => "0"
				,"JST" => "32400"
				);
	my %tzone =	("HST" => "-36000"
				,"PST" => "-28800"
				,"MST" => "-25200"
				,"CST" => "-21600"
				,"EST" => "-18000"
				,"GMT" => "0"
				,"JST" => "32400"
				);

	# ͤͿ줿硢ޤͿ줿ͤTZФ
	while(my ($key, $tgt) = each(%tzone)){
		$tz = $key if($tz eq $tgt);
	}

	# TZФ
	$time = $szone{$tz};

	# ˡͻ֤ɤȽꤷơ޻֤ʤTZľ
	if((gmtime(time - $localTimeZone))[4] >= 3 && (gmtime(time - $localTimeZone))[4] <= 9){
		unless($time){
			while(my ($key, $tgt) = each(%tzone)){
				$tz = $key if(($tz - 3600) eq $tgt);
			}
		}

		foreach my $k (keys %stime){
			if($tz eq $k){
				$tz = $stime{$k};
			}
		}
	}

	# TZФ
	$time = $szone{$tz};

	return $tz, $time;
}


##
# timeglobal($tz, $S, $M, $H, $d, $m, $y)
# ͡ʥॾλ狼顢GMTФ
# $tzϸ⤷ϻӻ
sub timeglobal($$$$$$$){
	my $tval = shift;
	my $times = timegm(@_);
	my $tz;
	$tz = (&nm_lib::tz2tzlag($tval))[1];

	$times -= $tz;
	return $times;
}



##
# ե뤫鹹Ф
sub file_time{
	my $file = shift;
	(stat($file))[9];
}


##
# ܥå󥯥ե뤫鹹Ф
sub lfile_time{
	my $file = shift;
	(lstat($file))[9];
}


##
# ե뤫ե륵Ф
sub file_size{
	my $file = shift;
	(stat($file))[7];
}


##
# եɤ߽Ф
sub read_file($){
	my $targetfile = shift;

	if(-e "$targetfile"){
		if(open(TGT, "$targetfile")){
			binmode TGT;
			my @read = <TGT>;
			close(TGT);

			return wantarray ? @read : join('', @read);
		}
	}
	return undef;
}


##
# ե˽񤭽Ф
sub write_file($$){
	my $targetfile = shift;
	my $contents = shift;

	if(open(TGT, ">$targetfile")){
		binmode TGT;
		print TGT $contents;
		close(TGT);

		return 1;
	}
	return undef;
}


##
# եɵ
sub add_file($$){
	my $targetfile = shift;
	my $contents = shift;

	if(open(TGT, ">>$targetfile")){
		binmode TGT;
		print TGT $contents;
		close(TGT);

		return 1;
	}
	return undef;
}


##
# parseURL($url)
sub parseURL($){
	local ($_) = shift;
	my $protocol = 'http';
	my $port = 80;
	my $server;
	my $userfile;

	if(m%^(\w+://)%o){
		s%^((\w+)://)%%;
		$protocol = $2;
	}

	unless($protocol eq 'file'){
		s%^([^/:]+)%%;
		$server = $1;
		if ( m%^(:(\d+))%o ){
			s%^(:(\d+))%%o;
			$port = $2;
		}
	}

	$userfile = $_;
	$userfile = "/$userfile" unless($userfile =~ m%^/%);
	return($protocol, $server, $port, $userfile);
}


##
# åȥȤեHTTP(HEAD/GET)
# ֤ͤϡHEADξƤΥإåGETξ200äƤƥȤ/顼(̵Ѵ)200ʳΤȤϤֹ֤
sub http_access($$;$$){
	my $TARGET = shift;
	my $REQ = shift;
	my $LMDTIME = shift;
	my $PROXYSRV = shift;
	my ($qur, $host, $port, $sel, $remote, $http_opt);
	my (@RET, @ready);

	$connect_timeout = 10;
	$read_timeout = 15;

	my @PROXY = &nm_lib::parseURL($PROXYSRV) if($PROXYSRV);
	my @URL = &nm_lib::parseURL($TARGET);
	if($URL[0] eq 'http'){
		$http_opt = $REQ." ";
		if($REQ eq 'HEAD'){
			if($PROXYSRV){
				$host = $PROXY[1];
				$port = $PROXY[2];
				$http_opt .= $TARGET." HTTP/1.1\012";
				$http_opt .= "Host: ".$PROXY[1]."\012";
			}else{
				$host = $URL[1];
				$port = $URL[2];
				$http_opt .= $URL[3]." HTTP/1.1\012";
				$http_opt .= "Host: ".$URL[1]."\012";
			}

		}elsif($REQ eq 'GET'){
			if($PROXYSRV){
				$host = $PROXY[1];
				$port = $PROXY[2];
				$http_opt .= $TARGET." HTTP/1.0\012";
				$http_opt .= "Host: " .$PROXY[1]."\012";
			}else{
				$host = $URL[1];
				$port = $URL[2];
				$http_opt .= $URL[3]." HTTP/1.0\012";
				$http_opt .= "Host: ".$URL[1]."\012";
			}
		}

		if($LMDTIME){
			$http_opt .= "If-modified-since: ";
			$http_opt .= &nm_lib::showdate($LMDTIME, "%ee%, %DD% %nn% %YYYY% %HH%:%TT%:%SS% GMT");
			$http_opt .= "\012";
		}
		$http_opt .= "User-Agent: ".$main::UserAgent."\012";
		$http_opt .= "Referer: ".$main::referer."\012";
		$http_opt .= "Connection: close\012";

		$sel = new IO::Select();
		$remote = IO::Socket::INET->new(Proto => "tcp", PeerAddr => $host, PeerPort => $port, Timeout => $connect_timeout);
		if($remote){
			$sel->add($remote);
			$remote->autoflush(1);
			print $remote $http_opt."\012";

			@ready = $sel->can_read($read_timeout);
			if(@ready){
				foreach my $sock (@ready){
					my $q;
					my $o = 0;

					$qur = <$remote>;

					if($REQ eq 'HEAD'){
						while($q = <$remote>){
							$q =~ s/\015\012/\012/og;
							$q =~ s/\015/\012/og;
							last if($q =~ /^\012$/i);
							push(@RET, $q);
						}

					}elsif($REQ eq 'GET'){
						while($q = <$remote>){
							if($o == 1){
								push(@RET, $q);
							}else{
								$q =~ s/\015\012/\012/og;
								$q =~ s/\015/\012/og;
								$o = 1 if($q =~ /^\012$/i);
							}
						}
					}
					close($remote);
				}

			}else{
				print STDERR "  read timeout ".$TARGET."\012";
				close($remote);
				return '408';
			}

		}else{
			print STDERR "  cannot open ".$TARGET." $!\012";
			return '408';

		}
	}

	if($qur =~ /200 OK/){
		unshift(@RET, $qur) if($REQ eq 'HEAD');
		return wantarray ? @RET : join('', @RET);

	}elsif($qur =~ /^HTTP/){
		if($REQ eq 'HEAD'){
			unshift(@RET, $qur);
			return wantarray ? @RET : join('', @RET);
		}else{
			$qur =~ s%^HTTP/1\.\d (\d\d\d) .*%$1%;
			chomp($qur);
			return $qur;
		}
	}else{
		return '400';
	}
}


##
# showdate(opt1, opt2)
# 1970ǯ11ÿ(time)顢ͳɽѴ֤֥롼 v2.5
# opt1 Ѵեǡ"now"Ǹ߻򡢤ʳͤꤹȤοͤѴ롣Ѵˤgmtime()ؿѤƤΤǡ륿ʤɤɽȤϤ餫timeglobal()ؿʤɤִƤȡ
# opt2 ֤դηɽʸ
# 	%YYYY%4
# 	%YY%2
# 	%MM%2
# 	%mm%2(0䴰̵)
# 	%DD%2
# 	%dd%2(0䴰̵)
# 	%HH%2
# 	%hh%2(0䴰̵)
# 	%TT%2ʬ
# 	%tt%2ʬ(0䴰̵)
# 	%SS%2
# 	%ss%2(0䴰̵)
# 	%WW%ܸ(ʸ)
# 	%EE%Ѹ(Ĺ)
# 	%ee%Ѹ(û)
# 	%NN%Ѹ(Ĺ)
# 	%nn%Ѹ(û)
# 	%XX%1970ǯ11ÿ
# 	%UU%110νܤ01120ܤ12131βܤ2Ȥ
# 	%uu%110νܤ11120ܤ22131βܤ3Ȥ
# 	%VV%110νܤa1120ܤb2131βܤcȤ
# 	%vv%110νܤA1120ܤB2131βܤCȤ
sub showdate($$){
	my ($MODE, $FORMAT) = @_;
	my $TIME;

	if($MODE eq "now"){
		$TIME = time;
	}else{
		$TIME = $MODE;
	}

	my @GMT = gmtime($TIME);

	$GMT[7] = ("", "", "", "", "", "", "")[$GMT[6]];
	$GMT[8] = (Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday)[$GMT[6]];
	$GMT[9] = (Sun, Mon, Tue, Wed, Thu, Fri, Sat)[$GMT[6]];
	$GMT[10] = (January, February, March, April, May, June, July, August, September, October, November, December)[$GMT[4]];
	$GMT[11] = (Jan, Feb, Mar, Apr, May, Jun, Jul, Aug, Sep, Oct, Nov, Dec)[$GMT[4]];

	$GMT[5] += 1900;
	$GMT[12] = $GMT[5];
	$GMT[12] =~ s/^\d+?(\d\d)$/$1/;

	$GMT[4]++;

	my ($xss, $xsss, $xst, $xstt);
	if($GMT[3] < 11){
		$xss = 0;
		$xsss = 1;
		$xst = 'a';
		$xstt = 'A';
	}elsif($GMT[3] < 21){
		$xss = 1;
		$xsss = 2;
		$xst = 'b';
		$xstt = 'B';
	}elsif($GMT[3] < 32){
		$xss = 2;
		$xsss = 3;
		$xst = 'c';
		$xstt = 'C';
	}

	if($MODE eq "null"){
		$FORMAT =~ s/%YYYY%/\-\-\-\-/g;
		$FORMAT =~ s/%YY%/\-\-/g;

		$FORMAT =~ s/%MM%/\-\-/g;
		$FORMAT =~ s/%DD%/\-\-/g;
		$FORMAT =~ s/%HH%/\-\-/g;
		$FORMAT =~ s/%TT%/\-\-/g;
		$FORMAT =~ s/%SS%/\-\-/g;

		$FORMAT =~ s/%mm%/\-\-/g;
		$FORMAT =~ s/%dd%/\-\-/g;
		$FORMAT =~ s/%hh%/\-\-/g;
		$FORMAT =~ s/%tt%/\-\-/g;
		$FORMAT =~ s/%ss%/\-\-/g;

		$FORMAT =~ s/%WW%/\-\-/g;
		$FORMAT =~ s/%EE%/\-\-\-\-\-\-/g;
		$FORMAT =~ s/%ee%/\-\-\-/g;
		$FORMAT =~ s/%NN%/\-\-\-\-\-\-/g;
		$FORMAT =~ s/%nn%/\-\-\-/g;

		$FORMAT =~ s/%XX%/\-\-\-\-\-\-\-\-\-\-/g;

		$FORMAT =~ s/%UU%/\-/g;
		$FORMAT =~ s/%uu%/\-/g;
		$FORMAT =~ s/%VV%/\-/g;
		$FORMAT =~ s/%vv%/\-/g;

	}else{
		$FORMAT =~ s/%YYYY%/$GMT[5]/g;
		$FORMAT =~ s/%YY%/$GMT[12]/g;

		$FORMAT =~ s/%mm%/$GMT[4]/g;
		$FORMAT =~ s/%dd%/$GMT[3]/g;
		$FORMAT =~ s/%hh%/$GMT[2]/g;
		$FORMAT =~ s/%tt%/$GMT[1]/g;
		$FORMAT =~ s/%ss%/$GMT[0]/g;

		$GMT[4] = "0$GMT[4]" if($GMT[4] <= 9);
		$FORMAT =~ s/%MM%/$GMT[4]/g;
		$GMT[3] = "0$GMT[3]" if($GMT[3] <= 9);
		$FORMAT =~ s/%DD%/$GMT[3]/g;
		$GMT[2] = "0$GMT[2]" if($GMT[2] <= 9);
		$FORMAT =~ s/%HH%/$GMT[2]/g;
		$GMT[1] = "0$GMT[1]" if($GMT[1] <= 9);
		$FORMAT =~ s/%TT%/$GMT[1]/g;
		$GMT[0] = "0$GMT[0]" if($GMT[0] <= 9);
		$FORMAT =~ s/%SS%/$GMT[0]/g;

		$FORMAT =~ s/%WW%/$GMT[7]/g;
		$FORMAT =~ s/%EE%/$GMT[8]/g;
		$FORMAT =~ s/%ee%/$GMT[9]/g;
		$FORMAT =~ s/%NN%/$GMT[10]/g;
		$FORMAT =~ s/%nn%/$GMT[11]/g;

		$FORMAT =~ s/%XX%/$TIME/g;

		$FORMAT =~ s/%UU%/$xss/g;
		$FORMAT =~ s/%uu%/$xsss/g;
		$FORMAT =~ s/%VV%/$xst/g;
		$FORMAT =~ s/%vv%/$xstt/g;
	}

	$FORMAT;
}



1;

