#!/usr/local/bin/perl
# ֤ʤĤߤ׹ץȡnm_tg.pl ver.2.3.1(20000125)
# "NATSU-MICAN" Copyright (C) 1998-2000 hiya All Rights Reserved.

## ᥤ

# 
use Time::Local;
use File::Copy 'cp';


# ʥ
$SIG{'INT'} = $SIG{'BUS'} = $SIG{'HUP'} = $SIG{'QUIT'} = $SIG{'TERM'} = $SIG{'ALRM'} = 'autokill';
if($ARGV[1] ne "nounix"){
	alarm(1200);
}

# 
$NOW = time;

$info_ref ={};
$remote_ref = {};
$remget_ref = {};

@files = ();
@urllist = ();
@cfgdat = ();
%remlist = {};


# ϥե
# nm.phmican.phjcode.plnm_lib.plLIRS.pmɤ߹
require './nm_lib.pl';
require './LIRS.pm';
$headfile = $ARGV[0];
require "$headfile";
require './jcode.pl';


## ¹Գ
$expiresCount = "23400";
$0 = $UserAgent;
print "\012$UserAgent nm_tg.pl start\012";


# ǥ쥯ȥư
chdir $basedir || die "Can't chdir $basedir\012";


# Ť⡼ȾTMPǥ쥯ȥ򤭤줤ˤ
@files = &nm_lib::alldirs($tmpdir);
foreach my $g (@files){
	unlink($g) if(&nm_lib::file_time($g) + (60 * 60 * 3) < $NOW);
}


# lockեκȹϻեǤФ
if(-e "natsumican.lock"){
	if(&nm_lib::lfile_time("natsumican.lock") + (60 * 60 * 6) < $NOW){
		# .lockե뤬Ƥ6ַвᤷƤ顢.lockե롣
		unlink("natsumican.lock") || print STDERR "natsumican.lock: $!\012";
print "natsumican.lock: lock file is older, delete lock file, and recovery.\012";

	}else{
print "natsu-mican $version: lock-file exists.\012";
		exit(0);
	}
}
open(TMP, ">natsumican.lock") || die "Can't create lock file\012";
close(TMP);
print "\012lock set\012";
open(TMP, ">$tmpdir"."natsumican.start") || die "Can't create start file\012";
close(TMP);


# cfgե(ե)ɤ߹
# оݥ
print "\012read cfg file: $cfg\012";
if($cfg =~ m%^http://%){
	my $cfg_file = (&nm_lib::parseURL($cfg))[3];
	$cfg_file =~ s%.*/([^/]+?)$%$1%;

	my $lmdtime;
	if(-e "$datadir$cfg_file"){
		$lmdtime = &nm_lib::file_time("$datadir$cfg_file");
	}else{
		$lmdtime = 0;
	}

	@cfgdat = &nm_lib::http_access($cfg, 'GET', $lmdtime, $http_proxy);

	if($cfgdat[0] =~ /^\d\d\d$/ || $cfgdat[0] eq ""){
		@cfgdat = ();
		@cfgdat = &nm_lib::read_file("$datadir$cfg_file");
	}else{
		my $out = join('', @cfgdat);
		$out =~ s%,file://.+?,%,,%g;
		&nm_lib::write_file("$tmpdir$cfg_file.$$", $out);
		rename("$tmpdir$cfg_file.$$", "$datadir$cfg_file");
		if($cfg_file =~ /.*\.gz$/i){
			&LIRS::xLIRS($gzip, "$datadir$cfg_file");
			@cfgdat = ();
			$cfg_file =~ s/(.*)\.gz$/$1/i;
			@cfgdat = &nm_lib::read_file("$datadir$cfg_file");
		}
	}

}else{
	@cfgdat = &nm_lib::read_file("$datadir$cfg");
}
for(@cfgdat){
	&jcode::convert(\$_, 'euc');
	unless(/^#/){
		if(/^LIRS.*/){
			my ($time, $lmd, $lag, $length, $url, $title, $author, $remote, $optional) = &LIRS::LIRS2list($_);
			$optional =~ s/\\,/%2c/g;
			my ($vurl, $key, $option, $etc) = split(",", $optional);
			$vurl =~ s/%2c/\,/ig;
			$key =~ s/%2c/\,/ig;
			$option =~ s/%2c/\,/ig;
			$etc =~ s/%2c/\,/ig;

			if($url){
				$url = &nm_lib::showdate(($NOW - (60 * 60 * 12)), $url);
				$vurl = &nm_lib::showdate(($NOW - (60 * 60 * 12)), $vurl);

				$url =~ s/%7e/~/io;
				push(@urllist, $url);
				$url =~ tr/A-Z/a-z/;
				$vurl =~ s/%7e/~/io;

				$info_ref->{$url}->{'LASTMOD'} = 0;
				$info_ref->{$url}->{'LAG'} = $lag;
				$info_ref->{$url}->{'TITLE'} = $title;
				$info_ref->{$url}->{'AUTHOR'} = $author;
				$info_ref->{$url}->{'VURL'} = $vurl;
				$info_ref->{$url}->{'KEY'} = $key;
				$info_ref->{$url}->{'OPTION'} = $option;
				$info_ref->{$url}->{'ETC'} = $etc;
			}
		}
	}
}
if($cfg ne $remcfg){
	# ⡼ȥƥ
print "read remote cfg file: $remcfg\012";
	@cfgdat = ();
	if($remcfg =~ m%^http://%){
		my $cfg_file = (&nm_lib::parseURL($remcfg))[3];
		$cfg_file =~ s%.*/([^/]+?)$%$1%;

		my $lmdtime;
		if(-e "$datadir$cfg_file"){
			$lmdtime = &nm_lib::file_time("$datadir$cfg_file");
		}else{
			$lmdtime = 0;
		}

		@cfgdat = &nm_lib::http_access($remcfg, 'GET', $lmdtime, $http_proxy);

		if($cfgdat[0] =~ /^\d\d\d$/ || $cfgdat[0] eq ""){
			@cfgdat = ();
			@cfgdat = &nm_lib::read_file("$datadir$cfg_file");
		}else{
			my $out = join('', @cfgdat);
			$out =~ s%,file://.+?,%,,%gm;
			&nm_lib::write_file("$tmpdir$cfg_file.$$", $out);
			rename("$tmpdir$cfg_file.$$", "$datadir$cfg_file");
			if($cfg_file =~ /.*\.gz$/i){
				&LIRS::xLIRS($gzip, "$datadir$cfg_file");
				@cfgdat = ();
				$cfg_file =~ s/(.*)\.gz$/$1/i;
				@cfgdat = &nm_lib::read_file("$datadir$cfg_file");
			}
		}
	}else{
		@cfgdat = &nm_lib::read_file("$datadir$remcfg");
	}
}else{
print "not read remote cfg file: \$cfg equal \$remcfg\012";
}
for(@cfgdat){
	&jcode::convert(\$_, 'euc');
	unless(/^#/){
		if(/^REMOTE.*/){
			chomp;
			s/\\,/%2c/g;
			($nul, $m_name, $name, $url, $filename, $get_url, $lag, $nul) = split(",", $_, 8);
			$m_name =~ s/%2c/\,/ig;
			$name =~ s/%2c/\,/ig;
			$url =~ s/%2c/\,/ig;
			$filename =~ s/%2c/\,/ig;
			$get_url =~ s/%2c/\,/ig;

			$remote_ref->{$url}->{'LASTMOD'} = 0;
			$remote_ref->{$url}->{'M_NAME'} = $m_name;
			$remote_ref->{$url}->{'NAME'} = $name;
			$remote_ref->{$url}->{'FILE'} = $filename;
			$remote_ref->{$url}->{'GET_URL'} = $get_url;
			$remote_ref->{$url}->{'LAG'} = $lag;
		}
	}
}


# ⡼ȾhttpǼŬ
print "\012get site information from remote info file\012";
foreach my $i (keys %$remote_ref){
print "remote info file get start: $i\012";
	&get_remote($i);
	&remote_data($i);
}


# åȥ̵ͭưڤؤ
if(@urllist){
	# åȥ꤬

	# åɤ߹
print "\012read cache file\012";
	open(FILE, "$outputdir$out");
	while(<FILE>){
		my ($time, $lmd, $lag, $length, $url, $title, $author, $remote, $optional) = &LIRS::LIRS2list($_);
		$optional =~ s/\\,/%2c/g;
		my ($vurl, $key, $option, $etc, $nul) = split(",", $optional);
		$vurl =~ s/%2c/\,/ig;
		$key =~ s/%2c/\,/ig;
		$option =~ s/%2c/\,/ig;
		$etc =~ s/%2c/\,/ig;

		$url =~ s/%7e/~/io;
		$url =~ tr/A-Z/a-z/;
		&set_info("CACHE", $url, $time, $lmd, $length, $lag, $title, $author, $remote, $vurl, $key, $option, $etc);
	}
	close(FILE);

	# Ȥľ(HEAD, GET, FILE, LENGTH)
print "\012direct get site information\012";
	foreach my $k (@urllist){
		my $kk = $k;
		$kk =~ tr/A-Z/a-z/;

		if($remget_ref->{$kk}->{'REFER'} eq "CACHE" || $remget_ref->{$kk}->{'LASTMOD'} <= 0){
print "get site information: $k\012";
			&site_access($k, $remget_ref->{$kk}->{'LASTMOD'});

		}else{
			my $y = $info_ref->{$kk}->{'VURL'};
			if($y =~ m%^file://%i){
print "get site information: $k\012";
				&site_access($k, '0');
			}
		}
	}

print "\012output data\012";

	open(OUT, ">$tmpdir$out.$$");
	foreach my $m (@urllist){
		my ($time, $lmd, $lag, $length, $title, $author, $remote, $s, $vurl, $key, $option, $etc, $refer, $remold, $masterurl, $hr, $r) = undef;
		$masterurl = $m;
		$m =~ s/%7e/~/io;
		$m =~ tr/A-Z/a-z/;
		$refer = $remget_ref->{$m}->{'REFER'};
		$time = $remget_ref->{$m}->{'LASTMOD'};
		$lmd = $remget_ref->{$m}->{'LMD'};
		$lag = $info_ref->{$m}->{'LAG'};
		$length = $remget_ref->{$m}->{'LENGTH'};
		$title = $info_ref->{$m}->{'TITLE'};
		$author = $info_ref->{$m}->{'AUTHOR'};
		$remote =  $remget_ref->{$m}->{'REMOTE'};
		$vurl = $info_ref->{$m}->{'VURL'};
		$key = $info_ref->{$m}->{'KEY'};
		$option = $info_ref->{$m}->{'OPTION'};
		$etc = $info_ref->{$m}->{'ETC'};

		$lag = $remget_ref->{$m}->{'LAG'} if($lag eq "");
		$lag = $localTimeZone if($lag eq "");
		$title = $remget_ref->{$m}->{'TITLE'} unless($title);
		$author = $remget_ref->{$m}->{'AUTHOR'} unless($author);
#		$vurl = $remget_ref->{$m}->{'VURL'} unless($vurl);
#		$key = $remget_ref->{$m}->{'KEY'} unless($key);
#		$option = $remget_ref->{$m}->{'OPTION'} unless($option);
#		$etc = $remget_ref->{$m}->{'ETC'} unless($etc);

		$option = &nm_lib::showdate(($time + $lag), "$option");

		$vurl =~ s%file://.+?$%%gm;
		$vurl =~ s/,/\\,/g;
		$key =~ s/,/\\,/g;
		$option =~ s/,/\\,/g;
		$etc =~ s/,/\\,/g;

		# LIRSκ
		$s = "$vurl,$key,$option,$etc,$refer";
		$r = &LIRS::list2LIRS($time, $lmd, $lag, $length, $masterurl, $title, $author, $remote, $s);
		#&jcode::convert(\$r, 'euc');
		print OUT $r;
	}
	close(OUT);
	rename("$tmpdir$out.$$", "$outputdir$out");

}else{
	# åȥ̵꤬

print "\012output data\012";

	open(OUT, ">$tmpdir$out.$$");

	foreach my $u (values %remlist){
		my ($time, $lmd, $lag, $length, $title, $author, $remote, $s, $vurl, $key, $option, $etc, $refer, $remold, $masterurl, $hr, $r) = undef;
		$masterurl = $u;
		$u =~ s/%7e/~/io;
#		$u =~ s/index\.htm(l)?$//io;
		$u =~ tr/A-Z/a-z/;
		$refer = $remget_ref->{$u}->{'REFER'};
		if($refer){
			$time = $remget_ref->{$u}->{'LASTMOD'};
			$lmd = $remget_ref->{$u}->{'LMD'};
			$lag = $remget_ref->{$u}->{'LAG'};
			$length = $remget_ref->{$u}->{'LENGTH'};
			$title = $remget_ref->{$u}->{'TITLE'};
			$author = $remget_ref->{$u}->{'AUTHOR'};
			$remote =  $remget_ref->{$u}->{'REMOTE'};
			$vurl = $remget_ref->{$u}->{'VURL'};
			$key = $remget_ref->{$u}->{'KEY'};
			$option = $remget_ref->{$u}->{'OPTION'};
			$etc = $remget_ref->{$u}->{'ETC'};

			$lag = $localTimeZone if($lag eq "");

			$option = &nm_lib::showdate(($time + $lag), "$option");

			$vurl =~ s%file://.+?$%%gm;
			$vurl =~ s/,/\\,/g;
			$key =~ s/,/\\,/g;
			$option =~ s/,/\\,/g;
			$etc =~ s/,/\\,/g;

			# LIRSκ
			$s = "$vurl,$key,$option,$etc,$refer";
			$r = &LIRS::list2LIRS($time, $lmd, $lag, $length, $masterurl, $title, $author, $remote, $s);
			#&jcode::convert(\$r, 'euc');
			print OUT $r;
		}
	}
	close(OUT);
	rename("$tmpdir$out.$$", "$outputdir$out");
}

# LIRSեΰ
&LIRS::cLIRS($gzip, "$outputdir$out");
print "output LIRS file\012";


# lockեκ
unlink("natsumican.lock") || print STDERR "natsumican.lock: $!\012";
print "\012unlock\012";


# 
exit(0);

## ᥤ󽪤










































## ֥롼


##
# 򥻥åȤ롣
sub set_info($$$$;$$$$$$$$){
	my ($refer, $url, $time, $lmd, $length, $lag, $title, $author, $remote, $vurl, $key, $option, $etc) = @_;
	my $detect;
	my $y = $info_ref->{$url}->{'VURL'};

	if($y =~ m%^file://%i){
		return undef if($refer ne "FILE");
	}

	$title = undef if($title =~ /\sUNKNOWN/i);
	$author = undef if($author =~ /\sUNKNOWN/i);
	$lag = undef if($lag eq "0");

	if($refer ne "CACHE"){
		$remget_ref->{$url}->{'LAG'} = $lag if($lag);
		$remget_ref->{$url}->{'TITLE'} = $title if($title);
		$remget_ref->{$url}->{'AUTHOR'} = $author if($author);
		$remget_ref->{$url}->{'OPTION'} = $option if($option);
		$remget_ref->{$url}->{'ETC'} = $etc if($etc);
		$remget_ref->{$url}->{'LENGTH'} = $length if($refer ne "LENGTH");
	}

	if($time > $NOW){
print "  wrong modified data...\012\012" if($refer =~ /(head|get|file|length)/i);
		return undef;
	}
	if($refer eq "LENGTH"){

	}elsif($refer eq "CACHE"){
		if($remget_ref->{$url}->{'LASTMOD'} > 0){
			return undef;
		}
	}else{
		if($NOW - (60 * 60 * 24 * 365 * 5) >= $time){
print "  cannot get information or older 5 years...\012\012" if($refer =~ /(head|get|file)/i);
			return undef;
		}
	}

	if($remget_ref->{$url}->{'LASTMOD'} > $time){
print "  older...\012\012" if($refer =~ /(head|get|file)/i);
		return undef;
	}

	$detect = $NOW - $lmd;
	if($detect > $expiresCount){
print "  expired...\012\012" if($refer =~ /(head|get|file|length)/i);
		return undef;
	}
	if($remget_ref->{$url}->{'LMD'} > $lmd){
print "  oldest...\012\012" if($refer =~ /(head|get|file|length)/i);
		return undef;
	}

	$remget_ref->{$url}->{'REFER'} = $refer;
	$remget_ref->{$url}->{'LASTMOD'} = $time;
	$remget_ref->{$url}->{'LMD'} = $lmd;
	$remget_ref->{$url}->{'LENGTH'} = $length;
	$remget_ref->{$url}->{'REMOTE'} = $remote;

	if($vurl){
		$vurl =~ s%file://.+?$%%gm;
		$remget_ref->{$url}->{'VURL'} = $vurl;
	}
	$remget_ref->{$url}->{'KEY'} = $key if($key);

print "  $time\012\012" if($refer =~ /(head|get|file|length)/i);
#print "$url: use cache\012" if($refer eq "CACHE");

	my ($refer, $url, $time, $lmd, $length, $lag, $title, $author, $remote, $vurl, $key, $option, $etc) = "";
}




##
# ⡼Ⱦ
sub get_remote($){
	my $u = shift;
	my $url = $remote_ref->{$u}->{'GET_URL'};
	my $out_file = $remote_ref->{$u}->{'FILE'};
	my $out_file_old = $out_file;
	my ($http_opt, $protocol, $host, $port, $userfile, $status) = undef;
	my $sel, $remote;

	my ($protocol, $host, $port, $userfile) = &nm_lib::parseURL($url);
	if($protocol eq "file"){
		if(-e $userfile){
			if(&nm_lib::file_time($userfile) > &nm_lib::file_time("$tmpdir$out_file")){
				$remote_ref->{$u}->{'LASTMOD'} = &nm_lib::file_time($userfile);
				cp($userfile, "$tmpdir$out_file");
				if($url =~ /.*\.gz$/i){
					&LIRS::xLIRS($gzip, "$tmpdir$out_file".".gz");
				}
			}else{
print "  not get, remote file is older: " . $remote_ref->{$u}->{'GET_URL'} . "\012";
			}
		}

	}else{
		my $lmdtime;
		if(-e "$tmpdir$out_file"){
			$lmdtime = &nm_lib::file_time("$tmpdir$out_file");
		}else{
			$lmdtime = 0;
		}

		my @headdat = &nm_lib::http_access($url, 'HEAD', $lmdtime, $http_proxy);

		if($headdat[0] =~ /200 OK/i){
			for(@headdat){
				if(/last-modified(.+)/i){
					$remote_ref->{$u}->{'LASTMOD'} = &nm_lib::lm2time($1, $localTimeZone);
				}
			}

			my $retdat = &nm_lib::http_access($url, 'GET', $lmdtime, $http_proxy);

			if($retdat =~ /^\d\d\d$/){
print "  ".$retdat;
print " remote file not get: " . $remote_ref->{$u}->{'GET_URL'} . "\012";

			}else{
				&nm_lib::write_file("$tmpdir$out_file.$$", $retdat);
				if($url =~ /.*\.gz$/i){
					rename("$tmpdir$out_file.$$", "$tmpdir$out_file".".gz");
					&LIRS::xLIRS($gzip, "$tmpdir$out_file".".gz");
				}else{
					rename("$tmpdir$out_file.$$", "$tmpdir$out_file");
				}
				my $data = &nm_lib::read_file("$tmpdir$out_file");
				$data =~ s%,file://.+?,%,,%gm;
				&nm_lib::write_file("$tmpdir$out_file", $data);
			}

		}elsif($headdat[0] =~ /HTTP/){
print "  remote file not get: " . $remote_ref->{$u}->{'GET_URL'} . "\012";

		}else{
print "  cannot get remote file: " . $remote_ref->{$u}->{'GET_URL'} . "\012";
		}
	}
}


##
# ⡼ȥե뤫
# hina.txt, DI, LIRSνϤб
sub remote_data($){
	my $u = shift;
	$u =~ s/%7e/~/io;
	my $file = $remote_ref->{$u}->{'FILE'};
	my $remlag = $remote_ref->{$u}->{'LAG'};
	my ($remote, $time, $lmd, $lag, $length, $url, $title, $author, $optional);
	my ($vurl, $key, $option, $etc);
	my ($detect, $expires, $ux);

	open(FILE, "$tmpdir$file");
	while(<FILE>){
		# EUCˤꤤ
		&jcode::convert(\$_, 'euc');

		s/\015\012/\012/og;
		s/\015/\012/og;

		# LIRSɤߤȤʬ
		if(/^LIRS.*/i){
			($time, $lmd, $lag, $length, $url, $title, $author, $remote, $optional) = &LIRS::LIRS2list($_);
			$optional =~ s/\\,/%2c/g;
			my ($vurl, $key, $option, $etc, $nul) = split(",", $optional);
			$vurl =~ s/%2c/\,/ig;
			$key =~ s/%2c/\,/ig;
			$option =~ s/%2c/\,/ig;
			$etc =~ s/%2c/\,/ig;

			$url =~ s/%7e/~/io;
#			$url =~ s/index\.htm(l)?$//io;
			$ux = $url;
			$url =~ tr/A-Z/a-z/;
			$remlist{$url} = $ux;
			&set_info($u, $url, $time, $lmd, $length, $lag, $title, $author, $remote, $vurl, $key, $option, $etc);
			($time, $lmd, $lag, $length, $url, $title, $author, $remote, $optional, $vurl, $key, $option, $etc) = undef;

		# DIɤߤȤʬ
		}elsif(/^URL:\s*(.*)/i){
			$url = $1;
			chomp($url);
			$url =~ s/[\?&]\d+(\#\w+)?$//;
			$url =~ s/%7e/~/io;
		}elsif(/^Last-Modified:\s*(.*)/i){
			$time = &nm_lib::lm2time($1, $remlag);
		}elsif(/^Last-Modified-Detected:\s*(.*)/i){
			$lmd = &nm_lib::lm2time($1, $remlag);
		}elsif(/^Title:\s*(.*)/i){
			$title = $1;
			chomp($title);
		}elsif(/^Content-Length:\s*(.*)/i){
			$length = $1;
			chomp($length);
		}elsif(/^Author-Name:\s*(.*)/i){
			$author = $1;
			chomp($author);
		}elsif(/^Authorized-Url:\s*(.*)/i){
			$remote = $1;
			chomp($remote);
		}elsif(/^Expire.?:\s*(.*)/i){
			$expires = &nm_lib::lm2time($1, $remlag);
		}elsif(/^$/){
			if($url ne "" && $time ne ""){
				if($expires > $NOW){
					$remote = $u unless($remote);
					$length = 0 unless($length);
#					$url =~ s/index\.htm(l)?$//io;
					$ux = $url;
					$url =~ tr/A-Z/a-z/;
					$remlist{$url} = $ux;
#					$lmd = $expires - $expiresCount;
					&set_info($u, $url, $time, $lmd, $length, $remlag, $title, $author, $remote);
				}
			}
			($time, $lmd, $lag, $length, $url, $title, $author, $remote, $optional, $vurl, $key, $option, $etc, $expires) = undef;

		# hina.txt
		}elsif(/HINA_OK/){
			if(/[^\(]<a\s+href=\"(.+?)\">(?!.{1,10}\()/i){
				$url = $1;
			}elsif(/\"(http\:\/\/.+?)\"/i){
				$url = $1;
			}

			# hina.txtȼͥپФ
			if(/\s?\[(\d*?)\]\s?\-\->/i){
				$pri = $1;
			}

			# URLΥߤ
			$url =~ s/[\?&]\d{1,10}.*$//;
			$url =~ s/%7e/~/io;
#			$url =~ s/index\.htm(l)?$//io;
			$ux = $url;
			$url =~ tr/A-Z/a-z/;
			$remlist{$url} = $ux;

			# Ф
			$time = &nm_lib::lm2time($_, $remlag);

			if($pri eq "0"){
				$lmd = $NOW - $expiresCount + (60 * 30 * 2);
			}elsif($pri eq "1"){
				$lmd = $NOW - $expiresCount + (60 * 30);
			}else{
				$lmd = $NOW - $expiresCount + 60;
			}

			&set_info($u, $url, $time, $lmd, 0, $remlag, "", "", $u);
			($time, $lmd, $lag, $length, $url, $title, $author, $remote, $optional, $vurl, $key, $option, $etc) = "";

		# ¾URLȻ郎ƱԤɽƤ
		}elsif(/\d+:\d+/){
			if(m%href=\"(.+?)\">%i){
				$url = $1;

				# URLθΥߤ
				$url =~ s/[\?&]\d+(\#\w+)?$//;
				$url =~ s/%7e/~/io;
#				$url =~ s/index\.htm(l)?$//io;
				$ux = $url;
				$url =~ tr/A-Z/a-z/;
				$remlist{$url} = $ux;

				# Ф
				$time = &nm_lib::lm2time($_, $remlag);

				$lmd = $NOW - $expiresCount + 60;
				$lmd = $remote_ref->{$u}->{'LASTMOD'} if($u =~ m%sharl.*wl.*%i);

				&set_info($u, $url, $time, $lmd, 0, $remlag, "", "", $u);
				($time, $lmd, $lag, $length, $url, $title, $author, $remote, $optional, $vurl, $key, $option, $etc) = "";
			}
		}
	}
}


##
# Ȥľ˻
sub site_access($;$){
	my $mos = shift;
	my $oldlastmod = shift;
	my $moss = $mos;
	$moss =~ tr/A-Z/a-z/;
	my ($target, $length, $modtime, $match, $author, $title) = "";
	my @req;
	my ($sel, $remote);

	$target = $info_ref->{$moss}->{'VURL'};
	$target = $mos if($target eq "");

print "(target file/server: $target)\012";

	if($target =~ m%http://%i){
		$match = $info_ref->{$moss}->{'KEY'};
		if($match eq ""){
print "  get information from HEAD request\012";
			@req = &nm_lib::http_access($target, 'HEAD', $oldlastmod, $http_proxy);

			if($req[0] =~ /200/){
				foreach my $q (@req){
					&jcode::convert(\$q, 'euc');

					if($q =~ /last-modified: (.*)/i){
						$modtime = &nm_lib::lm2time($1, $info_ref->{$mos}->{'LAG'});
					}
					if($q =~ /Content-Length: (.*)/i){
						$length = $1;
					}
					if($q =~ /Author: (.*)/i){
						$author = $1;
						&jcode::convert(\$author, 'euc');
					}
					if($q =~ /Title: (.*)/i){
						$title = $1;
						&jcode::convert(\$title, 'euc');
					}
				}

			}elsif($req[0] =~ /302/){
print "  ".$req[0]."\012";
				foreach my $q (@req){
					if($q =~ /Location: (.*)/i){
						$target = $1;
						$target =~ s/(\015|\012)//og;
						$modtime = "";
					}
				}

			}else{
print "  ".$req[0]."\012";
				return undef;

			}

			if($modtime ne ""){
#print "  $modtime\012";
				&set_info("HEAD", $moss, $modtime, $NOW, $length, $info_ref->{$mos}->{'LAG'}, $title, $author, $referer);
			}else{
print "    get information from HEAD request failed\012";
			}
		}

		@req = ();

		if($modtime eq ""){
print "  get information from GET request\012";
			@req = &nm_lib::http_access($target, 'GET', $oldlastmod, $http_proxy);

			if($req[0] =~ /^\d\d\d/){
print "  ".$req[0]."\012";
				return undef;

			}else{
				# ɽ
				my @s = ();
				my $tmp = join('', @req);
				if($tmp =~ /Content-Length: (.*?)/i){
					$length = $1;
				}
				$length = length($tmp) if($length eq "");

				&jcode::convert(\$tmp, 'euc');
				$tmp =~ s/\015\012/\012/og;
				$tmp =~ s/\015/\012/og;

				if($tmp =~ /meta.*?name="author".*?content="(.*?)"/i){
					$author = $1;
				}
				if($tmp =~ /<title.*?>(.+?)<\/title.*?>/i){
					$title = $1;
				}

				if($match){
					if($tmp =~ /.*\012.*$match.*\012.*\012/i){
						push(@s, $&);
					}
				}

				if($tmp =~ /(.*\012.*)modified(.*\012.*)\012/i){
					push(@s, $2);
					push(@s, $1);
				}
				if($tmp =~ /(.*\012.*)update(.*\012.*)\012/i){
					push(@s, $2);
					push(@s, $1);
				}
				if($tmp =~ /(.*\012.*)ǽ(.*\012.*)\012/i){
					push(@s, $2);
					push(@s, $1);
				}
				if($tmp =~ /(.*\012.*)(.*\012.*)\012/i){
					push(@s, $2);
					push(@s, $1);
				}
				if($tmp =~ /\$Id:.*\012.*\012/i){
					push(@s, $&);
				}

				for(@s){
					$modtime = &nm_lib::lm2time($_, $info_ref->{$moss}->{'LAG'});
					last if($modtime ne "");
				}

				if($modtime ne ""){
					# 
#print "  $modtime\012";
					&set_info("GET", $moss, $modtime, $NOW, $length, $info_ref->{$moss}->{'LAG'}, $title, $author, $referer);

				}else{
print "    get information from GET request failed\012";
				}
			}
		}

		if($modtime eq ""){
print "  get information from Content-Length\012";

			if($length ne ""){
				if($remget_ref->{$moss}->{'LENGTH'} <= "0"){
print "  add document length information\012";
print "  length:$length\012";
					&set_info("LENGTH", $moss, "0", $NOW, $length, $info_ref->{$moss}->{'LAG'}, $title, $author, $referer);

				}elsif(abs($remget_ref->{$moss}->{'LENGTH'} - $length) > 64){
print "  get information from document length\012";
print "  length:".$remget_ref->{$moss}->{'LENGTH'}." -> $length\012";
					&set_info("LENGTH", $moss, ($NOW - 1800), $NOW, $length, $info_ref->{$moss}->{'LAG'}, $title, $author, $referer);

				}else{
print "  not changed this site\012";
print "  length:".$remget_ref->{$moss}->{'LENGTH'}." -> $length\012";
					&set_info("LENGTH", $moss, "0", $NOW, $length, $info_ref->{$moss}->{'LAG'}, $title, $author, 0);
				}

			}
		}

	}elsif($target =~ m%^file://(.*)%i){
print "  get information from FILE time stamp\012";
		$modtime = &nm_lib::file_time($1);
		$length = &nm_lib::file_size($1);
		&set_info("FILE", $moss, $modtime, $NOW, $length, $info_ref->{$url}->{'LAG'}, "", "", $referer);
#print "  $modtime\012";
	}

}


##
# ֥롼
sub autokill{
	print STDERR "$!\012";
	unlink("natsumican.lock") || print STDERR "natsumican.lock: $!\012";
	exit(1);
}



1;
